/* Problem URL: https://codeforces.com/problemset/problem/1931/F */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;


void pre()
{

}

#define TEST 1

void solve()
{
    int n, k;
    cin >> n >> k;

    vvi p(k, vi(n));
    cin >> p;

    if (n == 1 || k == 1) {
        cout << "YES\n";
        return;
    }

    if (k == 2) {
        int i1 = 1;
        int i2 = 1;

        rep(i, n) {
            if (i1 >= n) {
                if (p[1][i2] != p[0][0]) {
                    cout << "NO\n";
                    return;
                }

                continue;
            }

            if (i2 >= n) {
                if (p[0][i1] != p[1][0]) {
                    cout << "NO\n";
                    return;
                }

                continue;
            }

            if (p[0][i1] == p[1][i2]) {
                i1++;
                i2++;
                continue;
            }

            if (p[0][i1] == p[1][0]) {
                i1++;
                continue;
            }

            if (p[1][i2] == p[0][0]) {
                i2++;
                continue;
            }

            cout << "NO\n";
            return;
        }
        
        cout << "YES\n";
        return;
    }

    V<bool> vis(n + 1);
    int cur = -1;

    int next = -1;

    int eq = n;

    nrep(i, 1, n) {
        if (next == -1) {
            if (p[0][i] == p[1][i] || p[0][i] == p[2][i]) {
                cur = p[0][i];
            } else if (p[1][i] == p[2][i]) {
                cur = p[1][i];
            } else {
                cout << "NO\n";
                return;
            }
        } else {
            cur = next;
        }

        next = -1;
        vis[cur] = true;
        rep(j, k) {
            if (p[j][i] != cur) {
                if (!vis[p[j][0]]) {
                    cout << "NO\n";
                    return;
                }

                if (next != -1 && p[j][i] != next) {
                    cout << "NO\n";
                    return;
                }

                next = p[j][i];
                continue;
            }

            if (vis[p[j][0]]) {
                cout << "NO\n";
                return;
            }
        }
    }

    cout << "YES\n";
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
